#
# based on openSUSE spec file
#

%define subrel 1
Name:           asar
Version:        3.2.9
Release:        %mkrel 1
Summary:        Creating atom-shell (electron) app packages
License:        MIT and ISC
Group:          Development/Other
Url:            https://github.com/electron/asar
Source0:        https://github.com/electron/asar/archive/refs/tags/v%{version}.tar.gz
# Created by prepare-vendor.sh
Source1:        vendor.tar.zst
Source2:        prepare_vendor.sh

BuildRequires:  jq
BuildRequires:  nodejs-packaging
BuildRequires:  npm
BuildRequires:  zstd

BuildArch:      noarch

%global __requires_exclude ^npm(.*)$

Provides:       nodejs-asar = %{version}

%description
Asar is a simple extensive archive format, it works like tar
that concatenates all files together without compression, while
having random access support.


%prep
%autosetup -p1 -a 1

%build
npm rebuild --verbose --foreground-scripts

%install
mkdir -pv %{buildroot}%{nodejs_sitelib}/@electron
mkdir -pv %{buildroot}%{_bindir}
cp -lr . %{buildroot}%{nodejs_sitelib}/@electron/asar
ln -srv %{buildroot}%{nodejs_sitelib}/@electron/asar/bin/asar.js %{buildroot}%{_bindir}/asar
# symlink old package name
ln -srv %{buildroot}%{nodejs_sitelib}/{@electron/,}asar
#fix shebang
sed -i '1s/env //' %{buildroot}%{nodejs_sitelib}/@electron/asar/bin/asar.js
cd %{buildroot}%{nodejs_sitelib}/asar

# Correct bogus version in package.json
jq -cj '.version="%{version}"' package.json > new
mv new package.json
#Remove development garbage
find -name example -print0 |xargs -r0 -- rm -rvf
find -name test -print0 |xargs -r0 -- rm -rvf
find -name typings -print0 |xargs -r0 -- rm -rvf
find -name @types -print0 |xargs -r0 -- rm -rvf
find -name .github -print0 |xargs -r0 -- rm -rvf
find -name .circleci -print0 |xargs -r0 -- rm -rvf
find -name '*.md' -type f -print -delete
find -name '*.markdown' -type f -print -delete
find -name '*.ts' -type f -print -delete
find -name '.*.yml' -type f -print -delete
find -name '.*ignore' -type f -print -delete
find -name 'snapcraft*' -type f -print -delete
find -name '.git*' -type f -print -delete
find -name yarn.lock -type f -print -delete
find -name '.yarn*' -type f -print -delete
find -name '.releaserc*' -type f -print -delete


%check
# https://docs.fedoraproject.org/en-US/packaging-guidelines/Node.js/#_build_testing_in_check
%{__nodejs} -e 'require("./")'

#We can't run tests, we don't have mocha available.


%files
%defattr(-,root,root)
%doc CHANGELOG.md README.md
%license LICENSE.md
%{_bindir}/asar
%{nodejs_sitelib}


%changelog
* Sun Apr 28 2024 squidf <squid-f> 3.2.9-1.1
- Fix group
- Build vendor with MGA nodejs version
- Clean up BR

* Wed Apr 17 2024 SurfZoid <surfzoid> 3.2.9-1
- Initial MGA version 3.2.9 based on openSUSE package
